
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _clkHz = 80_000_000
  _byteLimit = 100
   

VAR
  byte b_delimiter
  byte b_waitingToBeParsed[_byteLimit]
  byte b_byteMoveIndex
  byte b_RxString[_byteLimit]
  byte b_prefix[_byteLimit]
  byte b_suffix[_byteLimit]



  long l_frequencyRate
  long l_updateRateDenominator
  long l_pstSimulateCamWheel
  long l_pstSimulateCrankWheel
  long l_pstReadCamWheel
  long l_pstReadCrankWheel
  long l_myReceivedByte
  long l_sendAllValuesOnce
  long l_sendAllValues
  


  long pulserStack[100]
  long simulateCamWheelstack[100]



OBJ
  pst : "Parallax Serial Terminal"
  n : "Numbers"
  'fcam : "jm_freqin"
  'fcrank : "jm_freqin"
  f : "jm_freqin"



PUB Main | localIndex, localPeriod, localCamPeriod, localCrankPeriod, timeStamp, currentCam, previousCam1, previousCam2, previousCam3, previousCam4, previousCam5, previousCam6, trigger1, trigger2, trigger3, currentCrank, previousCrank1, previousCrank2, previousCrank3, previousCrank4, previousCrank5, previousCrank6, previous5CrankAverage, elapsedTime, previousGap, currentGap, toothGap, toothGap1, toothGap2, toothGap3, toothGap4, toothGap5, toothGap6, previousToothGapAverage, toothGapRpm, crankToothRpm, previousNum1, previousNum2, previousNum3, previousNum4, previousNum5, previousNum6, current, previous5average, toothRpm

  {localIndex := 0
  localCamPeriod := 0
  localCrankPeriod := 0
  'pstMain := 0
  b_delimiter := "="
  l_frequencyRate := 6000           ' 60hz=100rpm, 600hz=1000rpm,6000hz=10000rpm  
  l_updateRateDenominator := 2
  l_pstSimulateCamWheel := 0
  l_pstSimulateCrankWheel := 0
  l_pstReadCamWheel := 1 
  l_pstReadCrankWheel := 1


  previousCam6 := 0
  previousCam5 := 0
  previousCam4 := 0
  previousCam3 := 0
  previousCam2 := 0
  previousCam1 := 0
  currentCam := 0
 

  previousCrank6 := 0
  previousCrank5 := 0
  previousCrank4 := 0
  previousCrank3 := 0
  previousCrank2 := 0
  previousCrank1 := 0
  currentCrank := 0
  previous5CrankAverage := 0

  toothGap := 0
  toothGap1 := 0
  toothGap2 := 0
  toothGap3 := 0
  toothGap4 := 0
  toothGap5 := 0
  toothGap6 := 0
  elapsedTime := 0
  previousGap := 0 
  currentGap := 0
  previousToothGapAverage := 0
  toothGapRpm := 0
  crankToothRpm := 0

  trigger1 := false
  trigger2 := false
  trigger3 := false

 
  

  'cognew(crankPulser(16, @frequencyRate, 36, 2), @pulserStack)                 ' pulser(pin, pntr, presentTeeth, missingTeeth)
  cognew(crankPulser(4, @l_frequencyRate, 36, 2), @pulserStack)                   ' for protoboard (send)
  'cognew(simulateCamWheel(20, 10000, 2, 1, 106, 216, 5), @simulateCamWheel)      ' simulateCamWheel(simCamWheelPinNum, engineRPM, degreeOfTrigger1, degreeOfTrigger2, degreeOfTrigger3)
  'cognew(simulateCamWheel(2, 500, 2, 100, 100, 145, 5), @simulateCamWheelstack)    ' for protoboard, staggered triggers
  'cognew(simulateCamWheel(2, 10000, 2, 1, 121, 241, 5), @simulateCamWheel)         ' for protoboard, equal triggers




  pst.Start(115_200)
  pst.Clear
  pst.str(string("Beginning"))
  pst.Str(String(pst#NL))

  'f.init(19)                   ' for breadboard, read frequency  
  'fcam.init(3)                  ' for protoboard, read frequency
  'fcrank.init(5)                ' for protoboard, read frequency
  f.init(5)                     ' for protoboard, read frequency
  
  timeStamp := cnt }

  

   ' Initialize variables here 
  localIndex := 0
  'pstMain := 0
  b_delimiter := "="
  l_pstReadCamWheel := 1
  l_pstSimulateCamWheel := 0    ' Set this to 0 if you don't want to see the pst troubleshooting code lines, 1 if you do
  l_pstReadCrankWheel := 1    ' Set this to 0 if you don't want to see the pst troubleshooting code lines, 1 if you do
  l_frequencyRate := 6000           ' 60hz=100rpm, 600hz=1000rpm,6000hz=10000rpm


  
  pst.Start(115_200)
  pst.Clear
  pst.str(string("Beginning"))
  pst.Str(String(pst#NL))

 
   'cognew(readCrankWheel(19, 34), @readCrankWheelStack)
  'cognew(crankPulser(16, @frequencyRate, 36, 2), @pulserStack)                 ' pulser(pin, pntr, presentTeeth, missingTeeth)
  cognew(crankPulser(4, @l_frequencyRate, 36, 2), @pulserStack)                   ' for protoboard (send)
  'cognew(readCrankWheel(3, 34), @readCrankWheelStack)                          ' for protoboard (receive)
  'cognew(simulateCamWheel(20, 10000, 2, 1, 106, 216, 5), @simulateCamWheel)                                ' simCam2(simCamWheelPinNum, engineRPM, degreeOfTrigger1, degreeOfTrigger2, degreeOfTrigger3)
  'cognew(simulateCamWheel(2, 500, 2, 100, 100, 145, 5), @simulateCamWheelstack)                  ' for protoboard, staggered triggers
  'cognew(simulateCamWheel(2, 10000, 2, 1, 121, 241, 5), @simulateCamWheel)                  ' for protoboard, equal triggers
              
  'waitcnt((clkfreq*2)+cnt)

  previousCrank6 := 0
  previousCrank5 := 0
  previousCrank4 := 0
  previousCrank3 := 0
  previousCrank2 := 0
  currentCrank := 0
  previous5CrankAverage := 0

  {previousNum6b := 0
  previousNum5b := 0
  previousNum4b := 0
  previousNum3b := 0
  previousNum2b := 0
  currentb := 0
  previous5baverage := 0
  previousCnt := 0}

  toothGap1 := 0
  toothGap2 := 0

  trigger1 := false
  trigger2 := false
  trigger3 := false

  l_updateRateDenominator := 2
  



  


  'localIndex := 0
  'localCamPeriod := 0
  localCrankPeriod := 0

  b_delimiter := "="
  l_frequencyRate := 6000           ' 60hz=100rpm, 600hz=1000rpm,6000hz=10000rpm  
  l_updateRateDenominator := 2
  l_pstSimulateCamWheel := 0
  'l_pstSimulateCrankWheel := 0
  'l_pstReadCamWheel := 1 
  'l_pstReadCrankWheel := 1


  'previousCam6 := 0
  'previousCam5 := 0
  'previousCam4 := 0
  'previousCam3 := 0
  previousCam2 := 0
  previousCam1 := 0
  currentCam := 0
 

  previousCrank6 := 0
  previousCrank5 := 0
  previousCrank4 := 0
  previousCrank3 := 0
  previousCrank2 := 0
  previousCrank1 := 0
  currentCrank := 0
  previous5CrankAverage := 0

  toothGap := 0
  toothGap1 := 0
  toothGap2 := 0
  toothGap3 := 0
  toothGap4 := 0
  toothGap5 := 0
  toothGap6 := 0
  elapsedTime := 0
  previousGap := 0 
  currentGap := 0
  previousToothGapAverage := 0
  toothGapRpm := 0
  crankToothRpm := 0

  trigger1 := false
  trigger2 := false
  trigger3 := false

 
  

  'cognew(crankPulser(16, @frequencyRate, 36, 2), @pulserStack)                 ' pulser(pin, pntr, presentTeeth, missingTeeth)
  'cognew(crankPulser(4, @l_frequencyRate, 36, 2), @pulserStack)                   ' for protoboard (send)
  'cognew(simulateCamWheel(20, 10000, 2, 1, 106, 216, 5), @simulateCamWheel)      ' simulateCamWheel(simCamWheelPinNum, engineRPM, degreeOfTrigger1, degreeOfTrigger2, degreeOfTrigger3)
  'cognew(simulateCamWheel(2, 500, 2, 100, 100, 145, 5), @simulateCamWheelstack)    ' for protoboard, staggered triggers
  'cognew(simulateCamWheel(2, 10000, 2, 1, 121, 241, 5), @simulateCamWheel)         ' for protoboard, equal triggers




  'pst.Start(115_200)
  'pst.Clear
  'pst.str(string("Beginning"))
  'pst.Str(String(pst#NL))

  'f.init(19)                   ' for breadboard, read frequency  
  'fcam.init(3)                  ' for protoboard, read frequency
  'fcrank.init(5)                ' for protoboard, read frequency
  'f.init(5)                     ' for protoboard, read frequency
  
  'timeStamp := cnt





  
  

  'f.init(19)                     ' for breadboard, read frequency  
  'f.init(3)                     ' for protoboard, read frequency
  f.init(5)                     ' for protoboard, read frequency
  timeStamp := cnt

  repeat

    'localCamPeriod := fcam.period
    
    if(localCamPeriod) <> 0 and l_pstReadCamWheel == 1 
      previousCam6 := previousCam5
      previousCam5 := previousCam4
      previousCam4 := previousCam3
      previousCam3 := previousCam2
      previousCam2 := currentCam
      currentCam := localCamPeriod
        
      if previousCam6 <> 0 and previousCam5 <> 0 and previousCam4 <> 0 and previousCam3 <> 0 and previousCam2 <> 0

        {pst.dec(currentCam)
        pst.str(string(pst#NL))
        pst.dec(previousCam2)
        pst.str(string(pst#NL))
        pst.dec(previousCam3)
        pst.str(string(pst#NL))
        pst.dec(trigger2)
        pst.str(string(pst#NL)) }

          ' trigger1/(cba) 
          '              c > b*1.1               and             c  > a*1.1
          if((currentCam*100) > (previousCam2*110)) and ((currentCam*100) > (previousCam3*110)) and (trigger1 <> true)
            if((previousCam2*100) < (previousCam3*105)) and ((previousCam2*100) > (previousCam3*95))  ' b < a*1.1 and b > a*1.1
              trigger1 := true
              trigger2 := false
              trigger3 := false
              
          '  trigger2/(acb)    
          '          a*1.1 < c            
          if((currentCam*110) < (previousCam2*100)) and (trigger2 <> true)
            if(((currentCam*100) < (previousCam3*105)) and ((currentCam*100) > (previousCam3*95)))  ' a < b*1.05 and a > b*1.05
              if((previousCam2*100) > (previousCam3*110)) 'c > b*1.1
                trigger2 := true
                trigger3 := false
                trigger1 := false

          ' trigger3/(bac)      
          '               b < a*1.05              and             b > a*.95                             b*1.1 < c
          if(((currentCam*100) < (previousCam2*105)) and ((currentCam*100) > (previousCam2*95))) and ((currentCam*110) < (previousCam3*100)) and (trigger3 <> true) 
            if((previousCam2*110) < (previousCam3*100)) ' a*1.1 < c
              trigger3 := true
              trigger1 := false
              trigger2 := false

       

    localPeriod := f.period

    if (localPeriod) <> 0 and l_pstReadCrankWheel == 1
    '
      previousNum6 := previousNum5
      previousNum5 := previousNum4
      previousNum4 := previousNum3
      previousNum3 := previousNum2
      previousNum2 := current
      current := localPeriod 
      'count := count+1
      {pst.Dec(previousNum6)
      pst.str(string(pst#NL))
      pst.Dec(previousNum5)
      pst.str(string(pst#NL))
      pst.Dec(previousNum4)
      pst.str(string(pst#NL))
      pst.Dec(previousNum3)
      pst.str(string(pst#NL))
      pst.Dec(previousNum2)
      pst.str(string(pst#NL))
      pst.Dec(current)
      pst.str(string(pst#NL))
      pst.str(string(pst#NL))}
      
    if previousNum6 <> 0 and previousNum5 <> 0 and previousNum4 <> 0 and previousNum3 <> 0 and previousNum2 <> 0
      previous5average := ((previousNum6 + previousNum5 + previousNum4 + previousNum3 + previousNum2)/5)
       {pst.str(string("not zero"))
       pst.str(string(pst#NL))
       pst.dec(previous5average)
       pst.str(string(pst#NL))
       pst.dec(current)
       pst.str(string(pst#NL))
       pst.str(string(pst#NL))}
       if(current > 20000)
         pst.str(string("!!!!!!!!!!!!!"))
         pst.str(string(pst#NL))
      if ((current*100) > (previous5average * 110)) 'or ((current*100) < (previous5average * 90))
        'current := previousNum5        ' DO NOT COMMENT OUT
        current := previous5average        ' DO NOT COMMENT OUT
        toothGap := true
        {pst.str(string("true"))
        pst.str(string(pst#NL))}
      else
        
        if(toothGap == true)
          toothGap := false
          previousGap := currentGap
          currentGap := ||cnt
          {pst.str(string("true"))
          pst.str(string(pst#NL))}
          if((currentGap<>0) and (previousGap<>0))
            elapsedTime := (currentGap - previousGap)
            {pst.Dec(||elapsedTime)
            pst.str(string(pst#NL))
            pst.str(string(pst#NL))}
            {pst.dec(currentGap)
            pst.str(string(pst#NL))
            pst.dec(previousGap)
            pst.str(string(pst#NL))
            pst.str(string(pst#NL))}
            
            toothGap6 := toothGap5
            toothGap5 := toothGap4
            toothGap4 := toothGap3
            toothGap3 := toothGap2
            toothGap2 := toothGap1          
            toothGap1 := ||elapsedTime
          
          if toothGap6 <> 0 and toothGap5 <> 0 and toothGap4 <> 0 and toothGap3 <> 0 and toothGap2 <> 0 'and (((clkfreq/((toothGap1-toothGap2)/10))*60)/20) <> 0
                                
            {pst.Dec(toothGap6)
            pst.str(string(pst#NL))
            pst.Dec(toothGap5)
            pst.str(string(pst#NL))
            pst.Dec(toothGap4)
            pst.str(string(pst#NL))
            pst.Dec(toothGap3)
            pst.str(string(pst#NL))
            pst.Dec(toothGap2)
            pst.str(string(pst#NL))}
            'pst.Dec(toothGap1)
            'pst.str(string(pst#NL))
            'pst.str(string(pst#NL)) 
            'pst.Dec(((clkfreq/((toothGap1-toothGap2)/10))*60)/20)  ' write code here to reject an average lower than x.x
            previousToothGapAverage := ((toothGap6+toothGap5+toothGap4+toothGap3+toothGap2)/5)
            'pst.Dec(previousToothGapAverage)
            'pst.str(string(pst#NL))
            'pst.str(string(pst#NL)) 
            if (((toothGap1/10)*100) > ((previousToothGapAverage/10)*110)) or (((toothGap1/10)*100) < ((previousToothGapAverage/10)*90))
              toothGap1 := previousToothGapAverage
              'pst.str(string("*** "))
              'pst.Dec(toothGap1)
              'pst.str(string(pst#NL))

            else
              {pst.Dec(((clkfreq/((previousToothGapAverage)/100))*60)/100)
              pst.str(string(pst#NL))
              pst.str(string(pst#NL))}
              toothGapRpm := (((clkfreq/((previousToothGapAverage)/100))*60)/100)  
              

        
        
          if (((clkfreq/current)*60)/36) < 90
            pst.Dec(previousNum6)
            pst.str(string(pst#NL))
            pst.Dec(previousNum5)
            pst.str(string(pst#NL))
            pst.Dec(previousNum4)
            pst.str(string(pst#NL))
            pst.Dec(previousNum3)
            pst.str(string(pst#NL))
            pst.Dec(previousNum2)
            pst.str(string(pst#NL))
            pst.Dec(current)
            pst.str(string(pst#NL))
            pst.Dec(((clkfreq/current)*60)/36)
            pst.str(string(pst#NL, pst#NL))
            
          else
            'pst.Dec(((clkfreq/current)*60)/36)
            {pst.Dec(((clkfreq/previous5average)*60)/36)
            pst.str(string(pst#NL))}
            toothRpm := (((clkfreq/previous5average)*60)/36)      

{    if (localCrankPeriod) <> 0 and l_pstReadCrankWheel == 1
     '
       previousCrank6 := previousCrank5
       previousCrank5 := previousCrank4
       previousCrank4 := previousCrank3
       previousCrank3 := previousCrank2
       previousCrank2 := currentCrank
       currentCrank := localCrankPeriod
       {pst.dec(previousCrank6)
       pst.str(string(pst#NL))
       pst.dec(previousCrank5)
       pst.str(string(pst#NL))
       pst.dec(previousCrank4)
       pst.str(string(pst#NL))
       pst.dec(previousCrank3)
       pst.str(string(pst#NL))
       pst.dec(previousCrank2)
       pst.str(string(pst#NL))
       pst.dec(currentCrank)
       pst.str(string(pst#NL))}
     
     
      if previousCrank6 <> 0 and previousCrank5 <> 0 and previousCrank4 <> 0 and previousCrank3 <> 0 and previousCrank2 <> 0
        previous5CrankAverage := ((previousCrank6 + previousCrank5 + previousCrank4 + previousCrank3 + previousCrank2)/5)
        pst.str(string("not zero"))
        pst.str(string(pst#NL))
        pst.dec(previous5CrankAverage)
        pst.str(string(pst#NL))
        pst.dec(currentCrank)
        pst.str(string(pst#NL))
        pst.str(string(pst#NL))
       if ((currentCrank*100) > (previous5CrankAverage * 110)) 'or ((current*100) < (previous5average * 90))
         'current := previousNum5        ' DO NOT COMMENT OUT
         currentCrank := previous5CrankAverage        ' DO NOT COMMENT OUT
         toothGap := true
         pst.str(string("        true"))
         pst.str(string(pst#NL))
           

         
         
       else
         {pst.str(string("here"))
          pst.str(string(pst#NL))}
         if(toothGap == true)
           {pst.str(string("her2e"))
           pst.str(string(pst#NL))}
           toothGap := false
           previousGap := currentGap
           currentGap := ||cnt
           pst.str(string("cg"))
           pst.str(string(pst#NL))
           pst.dec(currentGap)
           pst.str(string(pst#NL))
           pst.dec(previousGap)
           pst.str(string(pst#NL))
           pst.dec(||(currentGap - previousGap))
           pst.str(string(pst#NL))
           pst.str(string(pst#NL))
           if((currentGap<>0) and (previousGap<>0))
             elapsedTime := (currentGap - previousGap)
             toothGap6 := toothGap5
             toothGap5 := toothGap4
             toothGap4 := toothGap3
             toothGap3 := toothGap2
             toothGap2 := toothGap1          
             toothGap1 := ||elapsedTime
             {pst.str(string("adding"))
             pst.str(string(pst#NL))}
             {pst.dec(toothGap6)
             pst.str(string(pst#NL))
             pst.dec(toothGap5)
             pst.str(string(pst#NL))
             pst.dec(toothGap4)
             pst.str(string(pst#NL))
             pst.dec(toothGap3)
             pst.str(string(pst#NL))
             pst.dec(toothGap2)
             pst.str(string(pst#NL))
             pst.dec(toothGap1)
             pst.str(string(pst#NL))}
             
           
           if toothGap6 <> 0 and toothGap5 <> 0 and toothGap4 <> 0 and toothGap3 <> 0 and toothGap2 <> 0 'and (((clkfreq/((toothGap1-toothGap2)/10))*60)/20) <> 0
               previousToothGapAverage := ((toothGap6+toothGap5+toothGap4+toothGap3+toothGap2)/5)
               {pst.str(string("here"))
               pst.str(string(pst#NL))}
               pst.str(string("et"))
               pst.str(string(pst#NL))
               pst.dec(toothGap1)
               pst.str(string(pst#NL))
               pst.dec(previousToothGapAverage) 
               pst.str(string(pst#NL)) 
               if (((toothGap1/10)*100) > ((previousToothGapAverage/10)*110)) or (((toothGap1/10)*100) < ((previousToothGapAverage/10)*90))
                 {pst.str(string("here2"))
                 pst.str(string(pst#NL))
                 pst.dec(toothGap1)
                 pst.str(string(pst#NL))
                 pst.dec(previousToothGapAverage)
                 pst.str(string(pst#NL))
                 pst.dec(toothGap6)
                 pst.str(string(pst#NL))
                 pst.dec(toothGap5)
                 pst.str(string(pst#NL))
                 pst.dec(toothGap4)
                 pst.str(string(pst#NL))
                 pst.dec(toothGap3)
                 pst.str(string(pst#NL))
                 pst.dec(toothGap2)
                 pst.str(string(pst#NL))
                 pst.dec(toothGap1)
                 pst.str(string(pst#NL))
                 pst.str(string(pst#NL))}
                 toothGap1 := previousToothGapAverage
               else
                 toothGapRpm := (((clkfreq/((previousToothGapAverage)/100))*60)/100)
                 pst.str(string("toothGapRpm: "))
                 pst.dec(toothGapRpm)
                 pst.str(string(pst#NL))  

           
           if (((clkfreq/currentGap)*60)/36) < 90
             {pst.Dec(previousCrank6)
             pst.str(string(pst#NL))
             pst.Dec(previousCrank5)
             pst.str(string(pst#NL))
             pst.Dec(previousCrank4)
             pst.str(string(pst#NL))
             pst.Dec(previousCrank3)
             pst.str(string(pst#NL))
             pst.Dec(previousCrank2)
             pst.str(string(pst#NL))
             pst.Dec(currentCrank)
             pst.str(string(pst#NL)) 
             pst.Dec(((clkfreq/currentCrank)*60)/36)
             pst.str(string(pst#NL, pst#NL))} 
             
         else
             crankToothRpm := (((clkfreq/previous5CrankAverage)*60)/36)  

     }

    if(cnt > (timeStamp + (clkfreq/l_updateRateDenominator)))
      timeStamp := cnt
      pst.Dec(toothGapRpm)
      pst.str(string(pst#NL))
      pst.Dec(toothRpm)
      pst.str(string(pst#NL))
      'pst.Dec(previous5CrankAverage)
      'pst.str(string(pst#NL))
      pst.Dec(((clkfreq/((currentCam+previousCam2+previousCam3)/10))*120)/10)
      {if ((((clkfreq/((currentCam+previousCam2+previousCam3)/10))*120)/10) < 490)
        pst.dec(currentCam)
        pst.str(string(pst#NL))
        pst.dec(previousCam2)
        pst.str(string(pst#NL))
        pst.dec(previousCam3)
        pst.str(string(pst#NL)) }
      pst.str(string(pst#NL))
      pst.str(@b_waitingToBeParsed)
      pst.str(string(pst#NL))
      pst.str(string(pst#NL)) 
   
   
    if (l_sendAllValuesOnce == 1)
      if(cnt > (timeStamp + (clkfreq/l_updateRateDenominator))) 
        sendValues
        l_sendAllValuesOnce := 0
   
    if (l_sendAllValues == 1)
      sendValues
           
   
   
    l_myReceivedByte := pst.RxCheck
     
    if l_myReceivedByte <> -1
      b_waitingToBeParsed[b_byteMoveIndex++] := l_myReceivedByte
     
      pst.str(@b_waitingToBeParsed)
      pst.str(string(pst#NL))
     
      if l_myReceivedByte == 13
        DelimiterFinder(@b_waitingToBeParsed)
        ByteFill(@b_waitingToBeParsed, 0, strsize(@b_waitingToBeParsed))
        b_byteMoveIndex := 0                         
                                

    {pst.str(string("cnt is "))
    pst.dec(cnt)
    pst.str(string(pst#NL))
    pst.str(string(pst#NL))}

PRI crankPulser(pin, pntr, presentTeeth, missingTeeth) | pulse, sync, timing, localIndex

'' Output 1 to 500Hz signal on pin
'' -- high-going pulse is fixed to 1ms
'' -- pntr is hub address of signal frequency (1 to 500Hz)

  ctra := (%00100 << 26) | pin                                  ' setup counter for pin
  frqa := 1
  phsa := 0

  dira[pin] := 1                                                ' make output 

  pulse := clkfreq / 10_000                                      ' ticks in 1ms
  {pst.Dec(pin)
  pst.Str(string("**",pst#NL))
  pst.Dec(presentTeeth)
  pst.Str(string("**",pst#NL))
  pst.Dec(missingTeeth)
  pst.Str(string("**",pst#NL))
  pst.Str(string("**",pst#NL))}
  
  sync := cnt                                                   ' sync with system clock  
  repeat
    
    repeat localIndex from 1 to (presentTeeth- missingTeeth)
      phsa := -pulse                                              ' create 1ms pulse
      timing := long[pntr]
      if (timing =< 0)                                            ' if zero
        timing := 7000                                             '   set to max
      else
        timing <#= 7000
      timing := clkfreq / timing                                  ' convert for waitcnt
      waitcnt(sync += timing)                                     ' hold for current hz setting

    
    repeat localIndex from 1 to (missingTeeth)
      'phsa := -pulse                                              ' create 1ms pulse
      timing := long[pntr]
      if (timing =< 0)                                            ' if zero
        timing := 7000                                             '   set to max
      else
        timing <#= 7000
      timing := clkfreq / timing                                  ' convert for waitcnt 
      waitcnt(sync += timing)
                               
PUB simulateCamWheel(simCamWheelPinNum, engineRPM, crankRotsToCamRots, degreeOfTrigger1, degreeOfTrigger2, degreeOfTrigger3, camTriggerDegreeWidth) | localIndex1, crankRpmPerSecond, camRpmPerSecond, localCnt, trigger1Wait, trigger2Wait, trigger3Wait, emtpySpace1Wait, emtpySpace2Wait, emtpySpace3Wait, cyclesPerDegOfRot

  
  
  dira[simCamWheelPinNum]~~
  outa[simCamWheelPinNum]~
  localIndex1 := 0

  crankRpmPerSecond := (engineRPM/60)                   ' 166.667 crank rots per second at 10k rpm
  camRpmPerSecond := (((engineRPM*10)/60)/2)                 ' 83.333 cam rots per second at 10k rpm
  cyclesPerDegOfRot := (((clkfreq/camRpmPerSecond)/360)*10)  ' 960000/360 at 10k or 2660

  trigger1Wait := (camTriggerDegreeWidth*cyclesPerDegOfRot)                     ' 13300 / 5 degrees
  trigger2Wait := (camTriggerDegreeWidth*cyclesPerDegOfRot)                     ' 13300 / 5 degrees
  trigger3Wait := (camTriggerDegreeWidth*cyclesPerDegOfRot)                     ' 13300 / 5 degrees
  emtpySpace1Wait := (degreeOfTrigger1*cyclesPerDegOfRot)                       ' 266000 / 100 degrees
  emtpySpace2Wait := (degreeOfTrigger2*cyclesPerDegOfRot)                       ' 266000 / 100 degrees 
  emtpySpace3Wait := (degreeOfTrigger3*cyclesPerDegOfRot)                       ' 385700 / 145 degrees    
                                                                                ' + = 957600   (((clkfreq/957600) * 60sec/min) * 2rots campercrank) = 10krpm
  pst.Dec(simCamWheelPinNum)
  pst.Str(string(pst#NL))
  pst.Dec(engineRPM)
  pst.Str(string(pst#NL))
  pst.Dec(crankRotsToCamRots)
  pst.Str(string(pst#NL))
  pst.Str(string(pst#NL))
  pst.Dec(degreeOfTrigger1)
  pst.Str(string(pst#NL))
  pst.Dec(degreeOfTrigger2)
  pst.Str(string(pst#NL))
  pst.Dec(degreeOfTrigger3)
  pst.Str(string(pst#NL))
  pst.Dec(camTriggerDegreeWidth)
  pst.Str(string(pst#NL))
  pst.Str(string(pst#NL))
  pst.Dec(crankRPMPerSecond)
  pst.Str(string(pst#NL))
  pst.Dec(camRPMPerSecond)
  pst.Str(string(pst#NL))
  pst.Dec(cyclesPerDegOfRot)
  pst.Str(string(pst#NL))
  pst.Dec(trigger1Wait)
  pst.Str(string(pst#NL))
  pst.Dec(emtpySpace1Wait)
  pst.Str(string(pst#NL))
  pst.Dec(emtpySpace2Wait)
  pst.Str(string(pst#NL))
  pst.Dec(emtpySpace3Wait)
  pst.Str(string(pst#NL))
  pst.Str(string(pst#NL))

  localCnt := cnt                                      

  repeat

    outa[simCamWheelPinNum]~~
    waitcnt(localCnt += trigger1Wait)                ' 6665                
    outa[simCamWheelPinNum]~
    'waitcnt(localCnt += (clkfreq/521))                  ' 160000-6665 
    waitcnt(localCnt += emtpySpace1Wait)
    outa[simCamWheelPinNum]~~
    waitcnt(localCnt += trigger2Wait)                ' 6665
    outa[simCamWheelPinNum]~
    'waitcnt(localCnt += (clkfreq/521))                  ' 160000-6665 
    waitcnt(localCnt += emtpySpace2Wait)
    outa[simCamWheelPinNum]~~
    waitcnt(localCnt += trigger3Wait)                ' 6665
    outa[simCamWheelPinNum]~
    'waitcnt(localCnt += (clkfreq/521))                  ' 160000-6665 
    waitcnt(localCnt += emtpySpace3Wait)
    

PUB elapsed_time_msec(p_TimeVar) | RightNow, ClockTicks
'can measure up to 26843 Milliseconds
'(2147483647 CounterTicks / 80.000.000 Hz = 26843 Milliseconds) 

  RightNow := cnt

  if RightNow < p_TimeVar                          
    ClockTicks := ||($FFFFFFFF - RightNow + p_TimeVar)  
  else
    ClockTicks := ||(RightNow - p_TimeVar)

  result := ClockTicks / (clkfreq / 1_000) 'calculate milliseconds


  '################################################################################
  'explanation how it works
  ' SPIN treats longs as SIGNED longs this means bit-No 32 represents the sign "+-"
  ' the systemcounter thinks of the 32bits as UNsigned meaning bit 32 is
  ' just another bit of the number and NOT a sign "+-" 
  ' if one or both values are negative it could happen
  ' that the result is negative too
  ' the command "||" calculates the absolute value of the SIGNED longs

  'even if the systemcounter has wrapped around since the snapshot of
  'systemcounter (value of parameter p_TimeVar),
  'this method calculates the timedifference in the right way
  
  'wrap-around example with easy numbers: counter maxvalue 1000
  'p_TimeVar containing value 980
  'time goes on counter wraps around from 1000 to 0
  'time goes on 
  'RightNow containing 300. This means 20 ticks until maximum 1000 and 300 ticks
  'since wrapping from 1000 to 0 in summary 320 ticks of time has gone
  'this is calculated by MaxCounter - p_TimeVar + RightNow
  'in numbers              1000     -   980     +   300     = 320
  'the real systemcounter has 32bits max value 2^32 -1 = 4294967295
  'hexadecimal $FFFFFFFF
  '################################################################################
 
'end of PUB elapsed_time_msec(p_TimeVar) | RightNow, ClockTicks


PUB DelimiterFinder(RxStringAddr) : idx | localCount, localIndex, pstDelimiterFinder                                            

  ' Initialize variables here
  localIndex := 0
  pstDelimiterFinder := 0

  repeat
    ifnot localCount := byte[RxStringAddr][idx++]                ' ifnot c, itterate to the next byte in byte[RxStringAddr] ?
      pst.Str(String("No delimiter, aborted"))
      pst.str(string(pst#NL))
      return -1

    pst.char(localCount)
    pst.str(string(pst#NL))  
  until localCount == b_delimiter'localCount == "="
 
  bytemove(@b_prefix, RxStringAddr, --idx)              ' idx points to the character after the delimiter, copy prefix
  b_prefix[idx] := 0                                    ' add terminator  
  RxStringAddr += idx + 1                               ' advance pointer, skip delimiter (+1)                                                 
  bytemove(@b_suffix, RxStringAddr, strsize(RxStringAddr) +1)                   ' copy tail including the existing terminator (+1)
  variableUpdator(@b_prefix, @b_suffix)




PUB variableUpdator(preAddr, sufAddr) | localIndex, pstVariableUpdator   ' variableUpdator(@prefix, @suffix)

  ' Initialize variables here
  localIndex := 0
  pstVariableUpdator := 0

  if strcomp(preAddr, string("updateRateDenominator")) 'strcomp(@prefix, var1)
    
    l_updateRateDenominator := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
    pst.str(l_updateRateDenominator)
    pst.str(string(pst#NL))

  if strcomp(preAddr, string("sendAllValuesOnce")) 'strcomp(@prefix, var1)
    
    l_sendAllValuesOnce := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
    pst.str(l_sendAllValuesOnce)
    pst.str(string(pst#NL))

  if strcomp(preAddr, string("sendAllValues")) 'strcomp(@prefix, var1)
    
    l_sendAllValues := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
    pst.str(l_sendAllValues)
    pst.str(string(pst#NL))    
    
  {if strcomp(preAddr, l_i1Name) 'strcomp(@prefix, var1)
    
    l_i1value := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec


    long sendAllValuesOnce
  long sendAllValues



  
     }





PUB sendValues | localIndex, pstSendAllValues

  ' Initialize variables here
  localIndex := 0
  pstSendAllValues := 0 

  pst.Str(String("sendAllValues()", pst#NL))

    
         